From a87c6ff382ea25f5d6fcaecb7b2ae3ba9a1c8e65 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Tue, 3 Dec 2019 16:23:08 +0800
Subject: [PATCH 17/76] ath11k: enable internal sleep clock

On x86 and thrid party platform, host need explicitly tell firmware to use
internal sleep clock. Some QCA6390 modules have OTP burnt with external
sleep clock selected, and these moduesl can't work expectedly unless
firmware selects internal sleep clock.

Add a field to hw_params to support this difference.

Tested QCA6390 on X86 platform.

Change-Id: Ie8dc08ecdb0b2e9ee8f50696ae9212dc7f7e5c08
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c |  2 ++
 drivers/net/wireless/ath/ath11k/hw.h   |  1 +
 drivers/net/wireless/ath/ath11k/qmi.c  | 13 +++++++++++++
 3 files changed, 16 insertions(+)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index ada06c3..bacc9e8 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -27,10 +27,12 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 			.board_size = IPQ8074_MAX_BOARD_DATA_SZ,
 			.cal_size =  IPQ8074_MAX_CAL_DATA_SZ,
 		},
+		.internal_sleep_clock = false,
 	},
 	{
 		.name = "qca6390",
 		.dev_id = ATH11K_HW_QCA6390,
+		.internal_sleep_clock = true,
 	}
 };
 
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index b2e49e2..b563b93 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -112,6 +112,7 @@ struct ath11k_hw_params {
 		size_t board_size;
 		size_t cal_size;
 	} fw;
+	bool internal_sleep_clock;
 };
 
 struct ath11k_fw_ie {
diff --git a/drivers/net/wireless/ath/ath11k/qmi.c b/drivers/net/wireless/ath/ath11k/qmi.c
index 83506ef..779732e 100644
--- a/drivers/net/wireless/ath/ath11k/qmi.c
+++ b/drivers/net/wireless/ath/ath11k/qmi.c
@@ -14,6 +14,8 @@
 #define BDF_FILE_NAME_PREFIX		"bdwlan"
 #define MAX_M3_FILE_NAME_LENGTH		13
 #define DEFAULT_M3_FILE_NAME		"m3.bin"
+#define SLEEP_CLOCK_SELECT_INTERNAL_BIT 0x02
+#define HOST_CSTATE_BIT 0x04
 
 static struct qmi_elem_info qmi_wlanfw_host_cap_req_msg_v01_ei[] = {
 	{
@@ -1537,6 +1539,17 @@ static int ath11k_qmi_host_cap_send(struct ath11k_base *ab)
 	req.cal_done_valid = 1;
 	req.cal_done = ab->qmi.cal_done;
 
+	if (ab->hw_params.internal_sleep_clock) {
+		req.nm_modem_valid = 1;
+		req.nm_modem |= HOST_CSTATE_BIT;
+		/* notify firmware about the sleep clock selection,
+		 * discussed with firmware, nm_modem_bit[1] used
+		 * for this purpose. host driver on third party platform
+		 * should select internal sleep clock.
+		 */
+		req.nm_modem |= SLEEP_CLOCK_SELECT_INTERNAL_BIT;
+	}
+
 	ret = qmi_txn_init(&ab->qmi.handle, &txn,
 			   qmi_wlanfw_host_cap_resp_msg_v01_ei, &resp);
 	if (ret < 0)
-- 
2.7.4

